Page MenuHomePhabricator

[analyzer] Hide developer-only checker/package options by default
ClosedPublic

Authored by Szelethus on May 12 2019, 4:40 PM.

Details

Summary

Followup to D60925, this time, for checker options. Non-checker configurations should receive the same treatment eventually.

The patch is marked WIP, because I am not really confident about osx checkers, and I can see valid uses for the rest of the options, but I might not be strict enough on this. Also, @NoQ suggested that hidden checker's options should be hidden by default, but I'm kind of hesitant about it, as described in D57858#1499414.

Also, the TableGen code is very ugly, I might want to have another attempt at making it nicer.

Diff Detail

Repository
rC Clang

Event Timeline

Szelethus created this revision.May 12 2019, 4:40 PM
Szelethus edited the summary of this revision. (Show Details)May 12 2019, 4:42 PM
Szelethus edited the summary of this revision. (Show Details)May 13 2019, 3:04 AM
NoQ added a comment.May 13 2019, 2:07 PM

Checker options are a different kind of animal entirely. I think we should definitely let the user fine-tune some modeling checkers, for instance, unix.DynamicMemoryModeling:Optimistic, despite us not really wanting to let anyone (even developers really) mess around whether unix.DynamicMemoryModeling should be enabled.

Hmm, great point!

I am not really confident about osx checkers

Let's hide CheckOSObject and unhide the rest. Hmm, Devin also mentioned that some help texts are also not user-friendly-enough (eg., the localization checker help with SymRegions and stuff), let's also hide this one.

I can see valid uses for the rest of the options, but I might not be strict enough on this

I think debug.AnalysisOrder options are worth hiding. Let's also hide the Optimistic Malloc Checker, it's clearly alpha. Probably hide alpha checker options if we hide alpha checkers (i.e., Clone Checker).

Szelethus updated this revision to Diff 200127.May 17 2019, 7:05 PM
Szelethus retitled this revision from [analyzer][WIP] Hide developer-only checker/package options by default to [analyzer] Hide developer-only checker/package options by default.
  • Hide several more checkers
  • Rename -analyzer-checker-option-help-hidden to -analyzer-checker-option-help-developer
NoQ accepted this revision.May 23 2019, 12:50 PM

Next!

This revision is now accepted and ready to land.May 23 2019, 12:50 PM
This revision was automatically updated to reflect the committed changes.